package org.springblade.system.expand.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.system.expand.entity.CustomMenu;
import org.springblade.system.expand.vo.CustomMenuVO;
import org.springblade.system.expand.wrapper.CustomMenuWrapper;
import org.springblade.system.expand.service.ICustomMenuService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-03-29
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/custommenu")
public class CustomMenuClient implements ICustomMenuClient {

    private final ICustomMenuService customMenuService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public CustomMenuVO detail(@SpringQueryMap CustomMenu customMenu) {
        CustomMenu detail = customMenuService.getOne(Condition.getQueryWrapper(customMenu));
        return CustomMenuWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<CustomMenuVO> list(@SpringQueryMap CustomMenu customMenu) {
        return CustomMenuWrapper.build().listVO(customMenuService.list(Condition.getQueryWrapper(customMenu)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody CustomMenu customMenu) {
        return customMenuService.save(customMenu);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody CustomMenu customMenu) {
        return customMenuService.updateById(customMenu);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody CustomMenu customMenu) {
        return customMenuService.saveOrUpdate(customMenu);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return customMenuService.deleteLogic(Func.toLongList(ids));
        }


}
